
;object:
;DWORD [object] = VTable Pointer
;DWORD [object+4] = n/a
;DWORD [object+8] = Slow game speed (Matrix-style)
;DWORD [object+12] = interval
;DWORD [object+16] = TimerID	(hardly used)
;DWORD [object+20] = run once value
;       bit 0 = should be run only once?
;       bit 1 = has been run once? (only valid if bit 0 set)

AT100MAIN:
push esi
push edi
mov edi,ecx
mov esi,[BaseData]

	mov eax,[edi+20]
	cmp eax,3
	jz RunAlreadyOnce100
	or BYTE [edi+20],2	;set run once bit (no matter if not used)

	cmp DWORD [edi+16],0
	jz CreateNewTimer100
	push DWORD [edi+16]	;kill timer if it exists (which might happen
	push 0			;if same ActionType instance is called again
	call [KillTimer]	;before interval has expired)
	mov DWORD [edi+16],0	;timer must be killed because ID is not updated
	
CreateNewTimer100:
	push TimerProc_100
	push DWORD [edi+12]	;interval
	push 0
	push 0
	call [SetTimer] 	;(return value discarded if error)
	test eax,eax
	jz TimerError100

	mov [LastTimerID],eax	    ;last created timer
	mov [edi+16],eax	    ;save TimerID (for kill by this function)
	mov edx,[GameSpeedVarADDR]
	mov eax,[edi+8] 	    ;slow game speed float
	mov [edx],eax		    ;set game speed to 'slow' mode

	TimerError100:

RunAlreadyOnce100:
pop edi
pop esi
ret

;----------------------------- interval procedure
TimerProc_100:
push esi
push eax
push ecx
push edx
mov esi,[BaseData]

	push DWORD [esp+28]	;TimerID in WM_TIMER message
	push 0
	call [KillTimer]

	mov eax,[esp+28]	;current TimerID
	cmp eax,[LastTimerID]
	jnz NotLastTimedCall100 ;only set game speed for last object called
	cmp [LastTimerID],0
	jz NotLastTimedCall100

	mov edx,[GameSpeedVarADDR]
	mov eax,[NormalGameSpeed]
	mov [edx],eax		;back to fast speed
	mov [LastTimerID],0

NotLastTimedCall100:
pop edx
pop ecx
pop eax
pop esi
ret 16