;============================================================
;MAIN VTABLES AND ADDRESSES FOR ALL EXECUTABLES
;============================================================
;Note: macros are in 'valuesDLL.inc'
;VTable format (P6 1.1 example):
;VTableStart:
;dd 0044CDB0h      ;FREES (uninitializes) object. This pointer varies
;                  ;between ActionTypes, but the method always does
;                  ;the same thing.
;dd 0040FDC0h      ;Calls the previous method. Same for all.
;                  ;
;dd MainCall       ;Main function for a certain ActionType
;dd 00468A60h      ;*, appears to be unused (can be 0)
;dd 0044AA60h      ;*, appears to be unused (can be 0)
;dd 004F2F80h      ;*, standard, appears to be unused (can be 0)
;dd 004F2F80h      ;*, standard, appears to be unused (can be 0)
;dd 0              ;data or possible pointer to data section, but unused
;dd 0              ;data, appears unused
;dd 0              ;possible pointer to data section, but unused
;* These can vary between ActionTypes, but don't seem to be
;  used often. The methods provided are the ones from ActionType 35.
;Note: Two last members are not present in some VTables.
;Note2: MainCall ends with ret 0 (no parameter stack displacement) and
;accepts the specified ActionType object in ecx. It does not appear
;to return a value.
;Note3: Although it may not be good programming practice (but hey, what
;is these days), the VTables are directly referenced inside the DLL
;by the executable.

;-----------------------------------
;see "virtual at esi" structure in valuesDLL.inc for definitions
;-----------------------------------
P6_1_1_Data:
;-----------------------------------
dd 'P611'
dd 0066678Ch
dd 00645CACh
dd 0064A760h
dd 00422E50h

dd 0073AF64h
dd 0073AE00h
dd 00739760h		;BaseDDSurfaceADDR
dd 0061AC20h

dd 004E7ACAh
dd 0040B792h
dd 00468A60h

dd 0065A000h
dd 0066A000h
dd 0040C90Ch

dd 004E7590h
dd 004E75C0h

dd 00669F70h+0Ah
dd 005E99EEh
dd 004A8227h		;near MSVCRT._open (file) call

dd 0073C6ECh
dd DOES_NOT_APPLY_TO_EXE
dd 0066A8F4h

dd 00450858h
dd 00450F91h
dd 00450F49h
dd 00450F47h

dd 00418550h
dd 00418930h

dd _exe_P6_1_1_Size
dd 00237000h
dd 00642000h

VTable_P6_1_1 AT100MAIN
VTable_P6_1_1 AT101MAIN
VTable_P6_1_1 AT102MAIN
VTable_P6_1_1 AT103MAIN
VTable_P6_1_1 AT104MAIN
VTable_P6_1_1 AT105MAIN

;-----------------------------------
K6_1_1_Data:
;-----------------------------------
dd 'K611'
dd 006347ECh
dd 00613CACh
dd 00618774h
dd 00422E30h

dd 00709084h
dd 00708F20h
dd 00707880h
dd 005E8E30h

dd 004E431Bh
dd 0040B602h
dd 004EAA20h

dd 00628000h
dd 00638000h
dd 0040C7ACh

dd 004E3DC0h
dd 004E3DF0h

dd 00637FD0h+0Ah
dd 005B773Eh
dd 004A5727h

dd 0070A81Ch
dd DOES_NOT_APPLY_TO_EXE
dd 0063896Ch

dd 004509C8h
dd 0045113Ch
dd 004510E6h
dd 004510E4h

dd 00418410h
dd 004187F0h

dd _exe_K6_1_1_Size
dd 00205000h
dd 00610000h

VTable_K6_1_1 AT100MAIN
VTable_K6_1_1 AT101MAIN
VTable_K6_1_1 AT102MAIN
VTable_K6_1_1 AT103MAIN
VTable_K6_1_1 AT104MAIN
VTable_K6_1_1 AT105MAIN

;-----------------------------------
P5_1_1_Data:
;-----------------------------------
dd 'P511'
dd 0066C77Ch
dd 0064BCACh
dd 00650774h
dd 00422FD0h

dd 00740F54h
dd 00740DF0h
dd 0073F750h
dd 0061D580h

dd 004E88BBh
dd 0040B762h
dd 00403220h			;TRESSTRDBG addr

dd 00660000h
dd 00670000h
dd 0040C8CCh

dd 004E8360h
dd 004E8390h

dd 0066FF58h+0Ah
dd 005EBF5Eh
dd 004A8BE7h

dd 007426D4h
dd DOES_NOT_APPLY_TO_EXE
dd 006708DCh

dd 00450B58h
dd 004512CCh
dd 00451276h
dd 00451274h

dd 00418590h
dd 00418970h

dd _exe_P5_1_1_Size
dd 0023A000h
dd 00648000h

VTable_P5_1_1 AT100MAIN
VTable_P5_1_1 AT101MAIN
VTable_P5_1_1 AT102MAIN
VTable_P5_1_1 AT103MAIN
VTable_P5_1_1 AT104MAIN
VTable_P5_1_1 AT105MAIN

;-----------------------------------
P5_Demo_Data:
;-----------------------------------
dd 'DEMO'
dd 00671864h
dd 0064FDA4h
dd 00654334h
dd 00426F20h

dd 00746C2Ch
dd 00746AC8h
dd 00745428h
dd 0061E400h

dd 004E758Bh
dd 0040B772h
dd 00403210h

dd 00664000h
dd 00675000h
dd 0040C92Ch

dd 004E7030h
dd 004E7060h

dd 00675148h+0Ah
dd 005EB52Eh
dd 004A5FA7h

dd 007483ACh
dd 00748921h
dd 00675924h

dd 0044DC88h
dd 0044E3FCh
dd 0044E34Bh
dd 0044E349h

dd 00418520h
dd 00418900h

dd _exe_P5_Demo_Size
dd 0023E000h
dd 0064C000h

VTable_P5_Demo AT100MAIN
VTable_P5_Demo AT101MAIN
VTable_P5_Demo AT102MAIN
VTable_P5_Demo AT103MAIN
VTable_P5_Demo AT104MAIN
VTable_P5_Demo AT105MAIN
