;============================================================
;MAIN NEWACTIONTYPE INITIALIZATION CODE
;============================================================
;->must return new object in esi if initsuccess
;[ebp-4]=used for LocalAlloc object size

include 'INATmacros.inc'
include 'INATcopystring.inc'

;====================================================================
INAT:			;eax = AT number
;====================================================================
push ebp		;THIS STACK SETUP CANNOT BE CHANGED
mov ebp,esp
sub esp,16		;possible local values, not necessarily used
push ecx
push edx
push ebx
push esi
push edi
mov esi,[BaseData]

	sub eax,100
	cmp eax,NUM_NEWACTIONTYPES
	jnb NoNewActionType
	
	jmp DWORD [ATINATTable+4*eax]

NoNewActionType:
	mov eax,[NO_AT_FOUND_JUMPDEST]
pop edi
pop esi
pop ebx
pop edx
pop ecx
mov esp,ebp
pop ebp
	jmp eax
;====================================================================
;DWORD list
;====================================================================
ATINATTable:
	dd	_AT100Init
	dd	_AT101Init
	dd	_AT102Init
	dd	_AT103Init
	dd	_AT104Init
	dd	_AT105Init
;====================================================================
_AT100Init:
;====================================================================
ALLOCAT 24
lea eax,[AT100]
mov [edi],eax
    xor ecx,ecx
mov [edi+4],ecx
	mov eax,[DefaultSlowSpeed]
mov [edi+8],eax
	mov eax,[DefaultInterval]
mov [edi+12],eax
mov [edi+16],ecx
mov [edi+20],ecx

GETVALUE Speed,0
SETVALUE value_float,3

GETVALUE Interval,1
SETVALUE value_int,4

GETVALUE Frame,2		;run only once?
SETVALUE value_bool,5

	jmp ExitINAT
;====================================================================
_AT101Init:
;====================================================================
ALLOCAT 16

lea eax,[AT101]
mov [edi],eax
mov DWORD [edi+4],0
	mov eax,[DefaultSlowSpeed]
mov DWORD [edi+8],eax
mov DWORD [edi+12],0

GETVALUE Speed,0
SETVALUE value_float,3

GETVALUE Frame,1
SETVALUE value_bool,4

	jmp ExitINAT
;====================================================================
_AT102Init:
;====================================================================
ALLOCAT 32
lea eax,[AT102]
mov [edi],eax
    xor eax,eax
mov [edi+4],eax
mov [edi+8],eax
mov [edi+12],eax
mov [edi+16],eax
mov [edi+20],eax
mov [edi+24],eax
mov [edi+28],eax		;0 for relative pointer

GETVALUE Sample,1
SETVALUE value_string,3

GETVALUE XPos,2
SETVALUE value_float,4

GETVALUE YPos,3
SETVALUE value_float,5

GETVALUE X,4
SETVALUE value_float,6

GETVALUE Y,5
SETVALUE value_float,7

	jmp SAVE_STRING_MAIN
;====================================================================
_AT103Init:
;====================================================================
ALLOCAT 24
lea eax,[AT103]
mov [edi],eax
    xor eax,eax
mov [edi+4],eax
mov [edi+8],eax
mov [edi+12],eax
    inc eax
mov [edi+16],DWORD -1
mov [edi+20],eax

GETVALUE Ammo,0
SETVALUE value_int,3

GETVALUE AltAmmoCount,1
SETVALUE value_int,4

GETVALUE LoopCount,2
SETVALUE value_int,5

GETVALUE Frame,3
SETVALUE value_int,6

	jmp ExitINAT
;====================================================================
_AT104Init:
;====================================================================
ALLOCAT 16
lea eax,[AT104]
mov [edi],eax
    xor eax,eax
mov [edi+4],eax
mov [edi+8],eax
mov [edi+12],eax

GETVALUE Frame,1
SETVALUE value_float,3

GETVALUE LoopCount,2
SETVALUE value_bool,4

	jmp ExitINAT
;====================================================================
_AT105Init:
;====================================================================
ALLOCAT 16
lea eax,[AT105]
mov [edi],eax
mov [edi+4],DWORD 0
mov [edi+8],DWORD -1
mov [edi+12],DWORD 1

GETVALUE Sample,1
SETVALUE value_string,3

GETVALUE LoopCount,2
SETVALUE value_bool,4

	jmp SAVE_STRING_MAIN	;save string to dynamic buffer

;====================================================================
ExitINAT:
;====================================================================
	mov eax,[AT_FOUND_JUMPDEST]
mov esi,edi
pop edi
add esp,4
pop ebx
pop edx
pop ecx
mov esp,ebp
pop ebp
	mov ebp,[esp+18h]	;seems standard amongst ActionTypes
	jmp eax

;====================================================================
UnableToAllocateMem:
;====================================================================
	mov eax,[AT_MEM_ERROR_JUMPDEST]
pop edi
pop esi
pop ebx
pop edx
pop ecx
mov esp,ebp
pop ebp
	mov ebp,[esp+18h]	;seems standard amongst ActionTypes
	jmp eax
